<template>
  <div>
    <div class="registerExample example">
      <h2>注册</h2>
      <div style="width: 300px; display: flex; justify-content: space-between;">
        用户名：
        <input type="text" v-model="userName" />
      </div>
      <div style="width: 300px; display: flex; justify-content: space-between; margin-top: 10px;">
        密码：
        <input type="text" v-model="password" />
      </div>
      <button style="margin-top: 10px;" @click="register">commit</button>
      <div class="return-mes" style="margin-top: 10px;">返回数据：{{mes1}}</div>
    </div>
    <hr />
    <div class="loginExample example">
      <h2>登录</h2>
      <div style="width: 300px; display: flex; justify-content: space-between;">
        用户名：
        <input type="text" v-model="userName" />
      </div>
      <div style="width: 300px; display: flex; justify-content: space-between; margin-top: 10px;">
        密码：
        <input type="text" v-model="password" />
      </div>
      <button style="margin-top: 10px;" @click="login">commit</button>
      <div class="return-mes" style="margin-top: 10px;">返回数据：{{mes2}}</div>
    </div>
    <hr />
    <div class="logoutExample example">
      <h2>登出</h2>
      <div style="width: 300px; display: flex; justify-content: space-between;">
        用户名：
        <input type="text" v-model="userName" />
      </div>
      <div style="width: 300px; display: flex; justify-content: space-between; margin-top: 10px;">
        密码：
        <input type="text" v-model="password" />
      </div>
      <button style="margin-top: 10px;" @click="logout">commit</button>
      <div class="return-mes" style="margin-top: 10px;">返回数据：{{mes3}}</div>
    </div>
    <hr />
    <div class="websocket example">
      <input type="text" v-model="userId" />
      <button @click="send">send</button>
      <button @click="init">connect</button>
      <button @click="close">disconnect</button>
    </div>
  </div>
</template>

<script>
export default {
  name: 'ApiExample',
  data () {
    return {
      // websocket
      userId: '',
      path: 'ws://121.199.79.177:10201/message/api/',
      socket: '',
      // apis
      userName: '',
      password: '',
      mes1: '',
      mes2: '',
      mes3: ''
    }
  },
  mounted: async function () {
    let data = await this.$api.helloUser()
    console.log('WORKING STATUS: ', data)
    data = await this.$api.helloBoard()
    console.log('WORKING STATUS: ', data)
    data = await this.$api.helloCompute()
    console.log('WORKING STATUS: ', data)
  },
  methods: {
    register: async function () {
      console.log(this.userName)
      console.log(this.password)
      this.mes1 = await this.$api.register(this.userName, this.password)
    },
    login: async function () {
      console.log(this.userName)
      console.log(this.password)
      this.mes2 = await this.$api.login(this.userName, this.password)
    },
    logout: async function () {
      console.log(this.userName)
      console.log(this.password)
      this.mes3 = await this.$api.logout()
    },
    init: function () {
      if (typeof WebSocket === 'undefined') {
        alert('您的浏览器不支持socket')
      } else {
        // 实例化socket
        this.socket = new WebSocket(this.path + this.userId)
        // 监听socket连接
        this.socket.onopen = this.open
        // 监听socket错误信息
        this.socket.onerror = this.error
        // 监听socket消息
        this.socket.onmessage = this.getMessage;
      }
    },
    open: function () {
      console.info('[Socket Local] 连接成功')
    },
    error: function () {
      console.error('[Socket Local] 连接错误')
    },
    getMessage: function (msg) {
      console.log(msg.data)
    },
    send: function () {
      this.socket.send(this.userId)
    },
    close: function () {
      this.socket.close()
      console.info('[Socket Local] 连接关闭')
    }
  },
  destroyed () {
    // 销毁监听
    this.socket.onclose = this.close
  }
}
</script>

<style scoped>
.example {
  margin-top: 20px;
  display: flex;
  flex-direction: column;
  align-items: center;
  justify-content: space-between;
}
.example input {
  width: 200px;
  height: 20px;
}
</style>
